3 # Copyright (c) 2005 Junio C Hamano.
6 USAGE='[--interactive | -i] [-v] [--force-rebase | -f] [--no-ff] [--onto <newbase>] [<upstream>|--root] [<branch>] [--quiet | -q]'
7 LONG_USAGE='git-rebase replaces <branch> with a new branch of the
8 same name. When the --onto option is provided the new branch starts
9 out with a HEAD equal to <newbase>, otherwise it is equal to <upstream>
10 It then attempts to create a new commit for each commit from the original
11 <branch> that does not exist in the <upstream> branch.
13 It is possible that a merge failure will prevent this process from being
14 completely automatic. You will have to resolve any such merge failure
15 and run git rebase --continue. Another option is to bypass the commit
16 that caused the merge failure with git rebase --skip. To restore the
17 original <branch> and remove the .git/rebase-apply working files, use the
18 command git rebase --abort instead.
20 Note that if <branch> is not specified on the command line, the
21 currently checked out branch is used.
23 Example: git-rebase master~1 topic
25 A---B---C topic A'\''--B'\''--C'\'' topic
27 D---E---F---G master D---E---F---G master
33 git rebase [-i] [options] [--onto <newbase>] [<upstream>] [<branch>]
34 git rebase [-i] [options] --onto <newbase> --root [<branch>]
35 git-rebase [-i] --continue | --abort | --skip
38 v,verbose! display a diffstat of what changed upstream
39 q,quiet! be quiet. implies --no-stat
40 onto=! rebase onto given branch instead of upstream
41 p,preserve-merges! try to recreate merges instead of ignoring them
42 s,strategy=! use the given merge strategy
43 no-ff! cherry-pick all commits, even if unchanged
44 m,merge! use merging strategies to rebase
45 i,interactive! let the user edit the list of commits to rebase
46 f,force-rebase! force rebase even if branch is up to date
47 X,strategy-option=! pass the argument through to the merge strategy
48 stat! display a diffstat of what changed upstream
49 n,no-stat! do not show diffstat of what changed upstream
50 verify allow pre-rebase hook to run
51 rerere-autoupdate allow rerere to update index with resolved conflicts
52 root! rebase all reachable commits up to the root(s)
53 autosquash move commits that begin with squash!/fixup! under -i
54 committer-date-is-author-date! passed to 'git am'
55 ignore-date! passed to 'git am'
56 whitespace=! passed to 'git apply'
57 ignore-whitespace! passed to 'git apply'
58 C=! passed to 'git apply'
60 continue! continue rebasing process
61 abort! abort rebasing process and restore original branch
62 skip! skip current patch and continue rebasing process
65 set_reflog_action rebase
71 ok_to_skip_pre_rebase=
73 When you have resolved this problem run \"git rebase --continue\".
74 If you would prefer to skip this patch, instead run \"git rebase --skip\".
75 To restore the original branch and stop rebasing run \"git rebase --abort\".
81 merge_dir="$GIT_DIR"/rebase-merge
82 apply_dir="$GIT_DIR"/rebase-apply
85 test "$(git config --bool rebase.stat)" = true && diffstat=t
89 allow_rerere_autoupdate=
90 # Non-empty if a rebase was in progress when 'git rebase' was invoked
92 # One of {am, merge, interactive}
94 # One of {"$GIT_DIR"/rebase-apply, "$GIT_DIR"/rebase-merge}
96 # One of {'', continue, skip, abort}, as parsed from command line
100 test "$(git config --bool rebase.autosquash)" = "true" && autosquash=t
102 read_basic_state () {
103 head_name=$(cat "$state_dir"/head-name) &&
104 onto=$(cat "$state_dir"/onto) &&
105 # We always write to orig-head, but interactive rebase used to write to
106 # head. Fall back to reading from head to cover for the case that the
107 # user upgraded git with an ongoing interactive rebase.
108 if test -f "$state_dir"/orig-head
110 orig_head=$(cat "$state_dir"/orig-head)
112 orig_head=$(cat "$state_dir"/head)
114 GIT_QUIET=$(cat "$state_dir"/quiet) &&
115 test -f "$state_dir"/verbose && verbose=t
116 test -f "$state_dir"/strategy && strategy="$(cat "$state_dir"/strategy)"
117 test -f "$state_dir"/strategy_opts &&
118 strategy_opts="$(cat "$state_dir"/strategy_opts)"
119 test -f "$state_dir"/allow_rerere_autoupdate &&
120 allow_rerere_autoupdate="$(cat "$state_dir"/allow_rerere_autoupdate)"
123 write_basic_state () {
124 echo "$head_name" > "$state_dir"/head-name &&
125 echo "$onto" > "$state_dir"/onto &&
126 echo "$orig_head" > "$state_dir"/orig-head &&
127 echo "$GIT_QUIET" > "$state_dir"/quiet &&
128 test t = "$verbose" && : > "$state_dir"/verbose
129 test -n "$strategy" && echo "$strategy" > "$state_dir"/strategy
130 test -n "$strategy_opts" && echo "$strategy_opts" > \
131 "$state_dir"/strategy_opts
132 test -n "$allow_rerere_autoupdate" && echo "$allow_rerere_autoupdate" > \
133 "$state_dir"/allow_rerere_autoupdate
141 test $status != 0 && printf "%s\n" "$output"
150 move_to_original_branch () {
153 message="rebase finished: $head_name onto $onto"
154 git update-ref -m "$message" \
155 $head_name $(git rev-parse HEAD) $orig_head &&
157 -m "rebase finished: returning to $head_name" \
159 die "Could not move back to $head_name"
164 run_specific_rebase () {
165 if [ "$interactive_rebase" = implied ]; then
172 run_pre_rebase_hook () {
173 if test -z "$ok_to_skip_pre_rebase" &&
174 test -x "$GIT_DIR/hooks/pre-rebase"
176 "$GIT_DIR/hooks/pre-rebase" ${1+"$@"} ||
177 die "The pre-rebase hook refused to rebase."
181 test -f "$apply_dir"/applying &&
182 die 'It looks like git-am is in progress. Cannot rebase.'
184 if test -d "$apply_dir"
187 state_dir="$apply_dir"
188 elif test -d "$merge_dir"
190 if test -f "$merge_dir"/interactive
193 interactive_rebase=explicit
197 state_dir="$merge_dir"
199 test -n "$type" && in_progress=t
206 ok_to_skip_pre_rebase=yes
209 ok_to_skip_pre_rebase=
211 --continue|--skip|--abort)
212 test $total_argc -eq 2 || usage
216 test 2 -le "$#" || usage
221 interactive_rebase=explicit
225 test -z "$interactive_rebase" && interactive_rebase=implied
238 strategy_opts="$strategy_opts $(git rev-parse --sq-quote "--$1")"
240 test -z "$strategy" && strategy=recursive
260 git_am_opt="$git_am_opt -q"
266 git_am_opt="$git_am_opt --whitespace=$1"
274 git_am_opt="$git_am_opt $1"
276 --committer-date-is-author-date|--ignore-date)
277 git_am_opt="$git_am_opt $1"
282 git_am_opt="$git_am_opt -C$1"
290 --rerere-autoupdate|--no-rerere-autoupdate)
291 allow_rerere_autoupdate="$1"
300 test $# -gt 2 && usage
304 test -z "$in_progress" && die "No rebase in progress?"
305 # Only interactive rebase uses detailed reflog messages
306 if test "$type" = interactive && test "$GIT_REFLOG_ACTION" = rebase
308 GIT_REFLOG_ACTION="rebase -i ($action)"
309 export GIT_REFLOG_ACTION
316 git rev-parse --verify HEAD >/dev/null ||
317 die "Cannot read HEAD"
318 git update-index --ignore-submodules --refresh &&
319 git diff-files --quiet --ignore-submodules || {
320 echo "You must edit all merge conflicts and then"
321 echo "mark them as resolved using git add"
328 output git reset --hard HEAD || exit $?
337 git symbolic-ref -m "rebase: aborting" HEAD $head_name ||
338 die "Could not move back to $head_name"
341 output git reset --hard $orig_head
347 # Make sure no rebase is in progress
348 if test -n "$in_progress"
351 It seems that there is already a '"${state_dir##*/}"' directory, and
352 I wonder if you are in the middle of another rebase. If that is the
354 git rebase (--continue | --abort | --skip)
355 If that is not the case, please
356 rm -fr '"$state_dir"'
357 and run me again. I am stopping in case you still have something
361 if test -n "$interactive_rebase"
364 state_dir="$merge_dir"
365 elif test -n "$do_merge"
368 state_dir="$merge_dir"
371 state_dir="$apply_dir"
374 if test -z "$rebase_root"
378 if ! upstream_name=$(git rev-parse --symbolic-full-name \
379 --verify -q @{upstream} 2>/dev/null)
382 error_on_missing_default_upstream "rebase" "rebase" \
383 "against" "git rebase <upstream branch>"
386 *) upstream_name="$1"
390 upstream=`git rev-parse --verify "${upstream_name}^0"` ||
391 die "invalid upstream $upstream_name"
392 upstream_arg="$upstream_name"
394 test -z "$onto" && die "You must specify --onto when using --root"
400 # Make sure the branch to rebase onto is valid.
401 onto_name=${onto-"$upstream_name"}
404 if left=${onto_name%...*} right=${onto_name#*...} &&
405 onto=$(git merge-base --all ${left:-HEAD} ${right:-HEAD})
409 die "$onto_name: there are more than one merge bases"
412 die "$onto_name: there is no merge base"
416 die "$onto_name: there is no merge base"
420 onto=$(git rev-parse --verify "${onto_name}^0") ||
421 die "Does not point to a valid commit: $1"
425 # If the branch to rebase is given, that is the branch we will rebase
426 # $branch_name -- branch being rebased, or HEAD (already detached)
427 # $orig_head -- commit object name of tip of the branch before rebasing
428 # $head_name -- refs/heads/<that-branch> or "detached HEAD"
432 # Is it "rebase other $branchname" or "rebase other $commit"?
436 if git show-ref --verify --quiet -- "refs/heads/$1" &&
437 orig_head=$(git rev-parse -q --verify "refs/heads/$1")
439 head_name="refs/heads/$1"
440 elif orig_head=$(git rev-parse -q --verify "$1")
442 head_name="detached HEAD"
444 echo >&2 "fatal: no such branch: $1"
449 # Do not need to switch branches, we are already on it.
450 if branch_name=`git symbolic-ref -q HEAD`
452 head_name=$branch_name
453 branch_name=`expr "z$branch_name" : 'zrefs/heads/\(.*\)'`
455 head_name="detached HEAD"
456 branch_name=HEAD ;# detached
458 orig_head=$(git rev-parse --verify "${branch_name}^0") || exit
462 require_clean_work_tree "rebase" "Please commit or stash them."
464 # Now we are rebasing commits $upstream..$orig_head (or with --root,
465 # everything leading up to $orig_head) on top of $onto
467 # Check if we are already based on $onto with linear history,
468 # but this should be done only when upstream and onto are the same
469 # and if this is not an interactive rebase.
470 mb=$(git merge-base "$onto" "$orig_head")
471 if test "$type" != interactive && test "$upstream" = "$onto" &&
472 test "$mb" = "$onto" &&
474 ! (git rev-list --parents "$onto".."$orig_head" | sane_grep " .* ") > /dev/null
476 if test -z "$force_rebase"
478 # Lazily switch to the target branch if needed...
479 test -z "$switch_to" || git checkout "$switch_to" --
480 say "Current branch $branch_name is up to date."
483 say "Current branch $branch_name is up to date, rebase forced."
487 # If a hook exists, give it a chance to interrupt
488 run_pre_rebase_hook "$upstream_arg" "$@"
490 if test -n "$diffstat"
492 if test -n "$verbose"
494 echo "Changes from $mb to $onto:"
496 # We want color (if set), but no pager
497 GIT_PAGER='' git diff --stat --summary "$mb" "$onto"
500 test "$type" = interactive && run_specific_rebase
502 # Detach HEAD and reset the tree
503 say "First, rewinding head to replay your work on top of it..."
504 git checkout -q "$onto^0" || die "could not detach HEAD"
505 git update-ref ORIG_HEAD $orig_head
507 # If the $onto is a proper descendant of the tip of the branch, then
508 # we just fast-forwarded.
509 if test "$mb" = "$orig_head"
511 say "Fast-forwarded $branch_name to $onto_name."
512 move_to_original_branch
516 if test -n "$rebase_root"
518 revisions="$onto..$orig_head"
520 revisions="$upstream..$orig_head"